"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Experiment(ProtocolElement):
    """
    An experimental preparation of a `Sample`.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "recordCreateTime",
        "recordUpdateTime",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import ga4gh as ga4gh_3_1_0

        return {
            "org.ga4gh.models.Experiment": ga4gh_3_1_0.Experiment,
        }

    __slots__ = [
        "id",
        "recordCreateTime",
        "recordUpdateTime",
        "description",
        "info",
        "instrumentDataFile",
        "instrumentModel",
        "library",
        "libraryLayout",
        "molecule",
        "name",
        "platformUnit",
        "runTime",
        "selection",
        "sequencingCenter",
        "strategy",
    ]

    def __init__(
        self,
        id,
        recordCreateTime,
        recordUpdateTime,
        description=None,
        info=dict,
        instrumentDataFile=None,
        instrumentModel=None,
        library=None,
        libraryLayout=None,
        molecule=None,
        name=None,
        platformUnit=None,
        runTime=None,
        selection=None,
        sequencingCenter=None,
        strategy=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_0.Experiment model.

        :param id:
            The experiment UUID. This is globally unique.
        :type id: str
        :param recordCreateTime:
            The time at which this record was created.    Format: ISO 8601,
            YYYY-MM-DDTHH:MM:SS.SSS (e.g. 2015-02-10T00:03:42.123Z)
        :type recordCreateTime: str
        :param recordUpdateTime:
            The time at which this record was last updated.   Format: ISO 8601,
            YYYY-MM-DDTHH:MM:SS.SSS (e.g. 2015-02-10T00:03:42.123Z)
        :type recordUpdateTime: str
        :param description:
            A description of the experiment.
        :type description: None | str
        :param info:
            A map of additional experiment information.
        :type info: dict[str, list[str]]
        :param instrumentDataFile:
            The data file generated by the instrument.   TODO: This isn't actually
            a file is it?   Should this be `instrumentData` instead?
        :type instrumentDataFile: None | str
        :param instrumentModel:
            The instrument model used as part of this experiment.     This maps to
            sequencing technology in BAM.
        :type instrumentModel: None | str
        :param library:
            The name of the library used as part of this experiment.
        :type library: None | str
        :param libraryLayout:
            The configuration of sequenced reads. (e.g. Single or Paired)
        :type libraryLayout: None | str
        :param molecule:
            The molecule examined in this experiment. (e.g. genomics DNA, total
            RNA)
        :type molecule: None | str
        :param name:
            The name of the experiment.
        :type name: None | str
        :param platformUnit:
            The platform unit used as part of this experiment. This is a
            flowcell-barcode   or slide unique identifier.
        :type platformUnit: None | str
        :param runTime:
            The time at which this experiment was performed.   Granularity here is
            variabel (e.g. date only).   Format: ISO 8601,
            YYYY-MM-DDTHH:MM:SS (e.g. 2015-02-10T00:03:42)
        :type runTime: None | str
        :param selection:
            The method used to enrich the target. (e.g. immunoprecipitation, size
            fractionation, MNase digestion)
        :type selection: None | str
        :param sequencingCenter:
            The sequencing center used as part of this experiment.
        :type sequencingCenter: None | str
        :param strategy:
            The experiment technique or strategy applied to the sample.   (e.g.
            whole genome sequencing, RNA-seq, RIP-seq)
        :type strategy: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.0"
